generic
	type TElemento is private;
package Contenedores is
	-- Tipo base para la implementacin de contenedores asociativos simples
	type Contenedor is abstract tagged limited private;
		-- Los contenedores se crean vacos

	-------------------------------
	-- Operaciones constructoras --
	-------------------------------	
	procedure Insertar(C: in out Contenedor; E: in TElemento) is abstract;
		-- Aade el elemento E al contenedor C, si no est ya presente
		-- Si E est en C no hace nada.

	procedure Extraer(C: in out Contenedor; E: in TElemento) is abstract;
		-- Se quita el elemento E del contenedor C. Si E no est en C,
		-- no hace nada

	procedure Vaciar(C: in out Contenedor) is abstract;
		-- Vaca el contenedor C, dejndolo sin elementos

	------------------------------
	-- Operaciones observadoras --
	------------------------------
	function Est(C: in Contenedor; E: in TElemento) return Boolean
		is abstract;
		-- Devuelve True si el elemento E est en el contenedor C
		-- y False si no

	function Es_Vaco(C: in Contenedor'Class) return Boolean;
		-- Devuelve True si el contenedor C est Vaco y False si no.

	function Tamao(C: in Contenedor) return Natural is abstract;
		-- Devuelve el nmero de elementos del contenedor C.
	
private
	-- El tipo Contenedor no tiene implementacin (null record).
	type Contenedor is abstract tagged limited null record;		
end Contenedores;