generic
	with function "<"(X,Y: in TElemento) return boolean is <>;
package Contenedores.AVLs is
	-- Tipo contenedor implementado con un rbol binario de bsqueda.
	type AVL is new Contenedor with private;
		-- Los contenedores se crean vacos.

	-------------------------------
	-- Operaciones constructoras --
	-------------------------------	
	procedure Insertar(C: in out AVL; E: in TElemento);
		-- Aade el elemento E al contenedor C, si no est ya presente.
		-- Si E est en C no hace nada.
		-- Si cuando se va a realizar la insercin no hay espacio,
		-- se lanza la excepcin Contenedor_Lleno.

	procedure Extraer(C: in out AVL; E: in TElemento);
		-- Se quita el elemento E del contendor C. Si E no est en C,
		-- no hace nada.

	procedure Vaciar(C: in out AVL);
		-- Vaca el contenedor C, dejndolo sin elementos.

	------------------------------
	-- Operaciones observadoras --
	------------------------------
	function Est(C: in AVL; E: in TElemento) return boolean;
		-- Devuelve True si el elemento E est en el contendor C
		-- y False si no.

	function Tamao(C: in AVL) return Natural;
		-- Devuelve el nmero de elementos del contenedor C.
private
	type Nodo_AVL;
	type Rbol_AVL is access Nodo_AVL;
	type Lista_Hijos is array(1..2) of Rbol_AVL;

	type Nodo_AVL is record
		Equilibrio : integer range - 1 .. 1;
		Clave: TElemento;
		Hijos: Lista_Hijos; --Hijos(1) = Hijo izqdo.
							--Hijos(2) = Hijo drcho.
	end record;

	type AVL is new Contenedor with record
		Elementos: rbol_AVL;
	end record;
end Contenedores.AVLs;
