#ifndef INC_AUTOAJUSTABLES
#define INC_AUTOAJUSTABLES
#include "binbusbasico.h"

template <class T, class P>
class AutoAjustable:public BinarioBusquedaBasico<T,P> {
   protected:
      void rotarSimple(P *&,int);
      void rotarDoble(P *&,int);
      void rotarDobleInversora(P *&,int);    
   public:
      AutoAjustable() {}
      virtual ~AutoAjustable() {}
};

// Funciones miembro de la clase Autoajustable
template <class T, class P>
   void AutoAjustable<T,P>::rotarSimple(P *&nodo,int rama)
   {
   	//Se intercambian los nodos
      P *hijo=nodo->enlaces[rama];
      int otraRama=1-rama;
      nodo->enlaces[rama]=hijo->enlaces[otraRama];
      hijo->enlaces[otraRama]=nodo;
      nodo=hijo;
   }

template <class T, class P>
   void AutoAjustable<T,P>::rotarDoble(P *&nodo,int rama)
   {
   	//Se intercambian los nodos
      P *nieto,*hijo=nodo->enlaces[rama];
      int otraRama=1-rama;
      nieto=hijo->enlaces[otraRama];
      nodo->enlaces[rama]=nieto->enlaces[otraRama];
      hijo->enlaces[otraRama]=nieto->enlaces[rama];
      nieto->enlaces[otraRama]=nodo;
      nieto->enlaces[rama]=hijo;
      nodo=nieto;
   }

template <class T, class P>
   void AutoAjustable<T,P>::rotarDobleInversora(P *&nodo,int rama)
   {
   	//Se intercambian los nodos
      P *nieto,*hijo=nodo->enlaces[rama];
      int otraRama=1-rama;
      nieto=hijo->enlaces[rama];
      nodo->enlaces[rama]=hijo->enlaces[otraRama];
      hijo->enlaces[rama]=nieto->enlaces[otraRama];
      nieto->enlaces[otraRama]=hijo;
      hijo->enlaces[otraRama]=nodo;
      nodo=nieto;
   }

#endif



