package rbolesBinariosBsqueda;

import contenedores.ContenedorOrdenado;

/**
 * @author zenon
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

public class rbolAVL
	extends rbolBinarioAjustable
	implements ContenedorOrdenado {
	private class NodoAVL extends NodoBinario {
		int fe;
		/**
		 * 
		 */
		public NodoAVL(Comparable info) {
			super(info);
			fe = 0;
		}
	}

	private NodoAVL raz;
	/**
	 * 
	 */
	public rbolAVL() {
		super();
		// TODO Auto-generated constructor stub
	}

	/* (non-Javadoc)
	 * @see contenedores.ContenedorOrdenado#extraer(java.lang.Comparable)
	 */
	public boolean est(Comparable valor) {
		// TODO Auto-generated method stub
		return super.est(raz, valor);
	}

	public void extraer(Comparable valor) {
		// TODO Auto-generated method stub
		BooleanoMutable modificaAltura = new BooleanoMutable();
		raz = extraer(raz, valor, modificaAltura);
		pruebaFactor(raz); //Borrarlo es una prueba
		pruebaAltura(raz); //Borrarlo es una prueba
	}
	private NodoAVL extraer(
		NodoAVL nodo,
		Comparable valor,
		BooleanoMutable disminuyeAltura) {
		int rama;
		if (nodo != null) {
			if (valor.compareTo(nodo.clave) == 0)
				/*Se ha encontrado el nodo a extraer
				 * tiene grado 0 o 1?
				 */
				if ((nodo.enlaces[0] == null) || (nodo.enlaces[1] == null)) {
					numElem--;
					disminuyeAltura.ponerVerdadero();
					if (nodo.enlaces[0] == null)
						return (NodoAVL) nodo.enlaces[1];
					else
						return (NodoAVL) nodo.enlaces[0];
				} else {
					/*Tiene grado 2, hay que extraer su sucesor
					 * en simtrico
					 */
					nodo.enlaces[1] =
						extraerSucesor(
							nodo,
							(NodoAVL) nodo.enlaces[1],
							disminuyeAltura);
					rama = 1;
				}
			else {
				/*Si valor es distinto de nodo.clave
				 * la extraccin se producir en el subrbol que corresponda
				 */
				if (valor.compareTo(nodo.clave) < 0)
					rama = 0;
				else
					rama = 1;
				nodo.enlaces[rama] =
					extraer(
						(NodoAVL) nodo.enlaces[rama],
						valor,
						disminuyeAltura);
			}
			//Un cambio de altura requiere ajustar el factor de equilibrio
			if (disminuyeAltura.valorLgico())
				nodo = corregirFactor(nodo, rama, disminuyeAltura);
		}
		return nodo;
	}

	private NodoAVL extraerSucesor(
		NodoAVL nodoExtraer,
		NodoAVL nodo,
		BooleanoMutable disminuyeAltura) {
		if (nodo.enlaces[0] == null) {
			//nodo es el sucesor
			nodoExtraer.clave = nodo.clave;
			numElem--;
			disminuyeAltura.ponerVerdadero();
			nodo = (NodoAVL) nodo.enlaces[1];
		} else {
			//El sucesor es descendiente de nodo
			nodo.enlaces[0] =
				extraerSucesor(
					nodoExtraer,
					(NodoAVL) nodo.enlaces[0],
					disminuyeAltura);
			//Un cambio de altura require ajustar el factor de equilibrio		
			if (disminuyeAltura.valorLgico())
				nodo = corregirFactor(nodo, 0, disminuyeAltura);
		}
		return nodo;
	}
	private NodoAVL corregirFactor(
		NodoAVL nodo,
		int rama,
		BooleanoMutable disminuyeAltura) {
		/*El rbol se desequilibra hacia el lado contrario
		 * de donde se ha extrado
		 */
		int factorEqui = 1 - 2 * rama;
		if (nodo.fe == 0) {
			//Se ha restablecido la condicin de equilibrio
			nodo.fe = -factorEqui;
			disminuyeAltura.ponerFalso();
		} else {
			if (nodo.fe == factorEqui)
				/*La extraccin "reequilibra" este subrbol, que 
				 * pierde altura
				 */
				nodo.fe = 0;
			else {
				/*Hay que rotar para restablecer el factor de equilibrio
				 * a los mrgenes permitidos
				 */
				NodoAVL hijo = (NodoAVL) nodo.enlaces[1 - rama];
				if (hijo.fe == factorEqui) {
					nodo = rotacinDoble(nodo, 1 - rama);

				} else {
					if (hijo.fe == 0)
						/*Se va a aplicar una rotacin simple que
						 * restablece la condicin de equilibrio
						 */
						disminuyeAltura.ponerFalso();
					nodo = rotacinSimple(nodo, 1 - rama);
				}
			}
		}
		return nodo;
	}
	/* (non-Javadoc)
	 * @see contenedores.ContenedorOrdenado#insertar(java.lang.Comparable)
	 */
	public void insertar(Comparable valor) {
		// TODO Auto-generated method stub
		BooleanoMutable modificaAltura = new BooleanoMutable();
		raz = insertar(raz, valor, modificaAltura);
		pruebaFactor(raz); //Borrarlo es una prueba
		pruebaAltura(raz); //Borrarlo es una prueba
	}

	private NodoAVL insertar(
		NodoAVL nodo,
		Comparable valor,
		BooleanoMutable aumentaAltura) {
		if (nodo == null) {
			//El nuevo valor se inserta como hoja
			nodo = new NodoAVL(valor);
			numElem++;
			aumentaAltura.ponerVerdadero();
		} else {
			//Si valor es igual a nodo.clave no se inserta
			if (valor.compareTo(nodo.clave) != 0) {
				int rama, factorEqui;
				//La insercin continua en el subrbol adecuado
				if (valor.compareTo(nodo.clave) < 0) {
					rama = 0;
				} else {
					rama = 1;
				}
				nodo.enlaces[rama] =
					insertar(
						(NodoAVL) nodo.enlaces[rama],
						valor,
						aumentaAltura);
				factorEqui = 1 - 2 * rama;
				/*Si la altura aumenta hay que comprobar
				  los factores de equilibrio*/
				if (aumentaAltura.valorLgico()) {
					/*Cambio del factor de equilibrio de los nodos
					 *del camino desde el nuevo nodo al crtico */
					if (nodo.fe == 0)
						nodo.fe = factorEqui;
					else { //nodo crtico 
						/*Si se ha insertado en el subrbol de mayor altura 
						 * hay que rotar
						 */
						if (nodo.fe == factorEqui) {
							/*La rotacin se elige comparando los factores de equilibrio
							 * del nodo crtico y el nodo discriminante (raz de la rama
							 * donde se ha insertado)
							 */
							NodoAVL hijo = (NodoAVL) nodo.enlaces[rama];
							if (hijo.fe == factorEqui) {
								nodo = rotacinSimple(nodo, rama);

							} else {
								nodo = rotacinDoble(nodo, rama);
							}
						} else
							//Modificacin del factor de equilibrio del nodo crtico
							nodo.fe = 0;
						//Se ha restablecido la condicin de equilibrio
						aumentaAltura.ponerFalso();
					}
				}
			}
		}
		return nodo;
	}

	private NodoAVL rotacinDoble(NodoAVL nodo, int rama) {
		nodo = (NodoAVL) super.rotacinDoble(nodo, rama);
		NodoAVL hijo = (NodoAVL) nodo.enlaces[rama];
		NodoAVL otroHijo = (NodoAVL) nodo.enlaces[1 - rama];
		//Se ajustan los factores de equilibrio
		hijo.fe = (1 - 2 * rama - nodo.fe) / 2;
		otroHijo.fe = (2 * rama - nodo.fe - 1) / 2;
		nodo.fe = 0;
		return nodo;
	}

	private NodoAVL rotacinSimple(NodoAVL nodo, int rama) {
		nodo = (NodoAVL) super.rotacinSimple(nodo, rama);
		NodoAVL hijo = (NodoAVL) nodo.enlaces[1 - rama];
		//Se ajustan los factores de equilibrio
		hijo.fe = hijo.fe - nodo.fe;
		nodo.fe = -hijo.fe;
		return nodo;
	}

	public void vaciar() {
		// TODO Auto-generated method stub
		raz = null;
		numElem = 0;
	}

	public void pruebaFactor(NodoAVL nodo) //Borrarlo es una prueba
	{
		if (nodo != null) {
			pruebaFactor((NodoAVL) nodo.enlaces[0]);
			if (nodo.fe != 0 && nodo.fe != 1 && nodo.fe != -1)
				System.out.println("El factor de equilibrio no es correcto");
			pruebaFactor((NodoAVL) nodo.enlaces[1]);
		}
	}

	public int pruebaAltura(NodoAVL nodo) //Borrarlo es una prueba
	{
		if (nodo == null)
			return 0;
		else {
			int hizq, hder;
			hizq = pruebaAltura((NodoAVL) nodo.enlaces[0]);
			hder = pruebaAltura((NodoAVL) nodo.enlaces[1]);
			if (Math.abs(hizq - hder) >= 2)
				System.out.println("La diferencia de alturas no es correcta");
			else if (hizq - hder != nodo.fe)
				System.out.println(
					"El factor de equilibrio no coincide con la diferencia de alturas");
			return (hizq > hder) ? hizq + 1 : hder + 1;
		}
	}
}
